﻿Public Class Form2

    'メール送信を実行する
    Private Sub Send_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Send.Click
        '事前に必要な情報
        Dim Server As String = "mail.example.jp"
        Dim ServerPort As Integer = 25
        Dim FromAddress As String = "test@example.jp"
        'SMTPサーバーを利用するときに認証が必要な場合は、以下の情報が必要
        Dim UserID As String = "userid"
        Dim Pass As String = "password"


        '------------------------------------------------------
        '送信用のメールクラスを作成します
        '------------------------------------------------------
        Dim mail As New TKMP.Writer.MailWriter

        '差出人のアドレスをセットします
        mail.FromAddress = FromAddress 'SMTPサーバーの問い合わせに応答するための差出人です。送信先には伝わりません
        'あて先アドレスをセットします
        mail.ToAddressList.Add(textToAddress.Text) '実際にメールを配信するあて先です。BCCなどの処理はここへのみ登録します。
        '本文のクラスを作成します
        Dim part As New TKMP.Writer.TextPart(textBody.Text)

        '添付ファイルを持つマルチパートのメールを作成する場合は以下のようにします
        'Dim part As New TKMP.Writer.MultiPart( _
        'New TKMP.Writer.TextPart(textBody.Text), _
        'New TKMP.Writer.FilePart("c:\temp.txt") _
        ')
        '送信メールクラスに本文を登録します
        mail.MainPart = part

        'ヘッダ情報を追加します
        mail.Headers.Add("From", FromAddress) '相手のメーラーで「差出人」として表示されます
        mail.Headers.Add("To", textToAddress.Text) '相手のメーラーで「あて先」として表示されます
        mail.Headers.Add("Subject", textSubject.Text)  'メールの件名
        mail.Headers.Add("X-Mailer", "TKMP Version 2.0.0") '付加情報など

        '------------------------------------------------------
        'サーバーへ接続します
        '------------------------------------------------------
        Dim smtp As TKMP.Net.SmtpClient = New TKMP.Net.SmtpClient(Server, ServerPort)

        'SMTPサーバーを利用する場合に認証が必要なときは以下のようにインスタンスを作成します
        'Dim logon As New TKMP.Net.AuthLogin(UserID, Pass)
        'Dim smtp As New TKMP.Net.SmtpClient(Address, ServerPort, logon)

        '通信ログのイベント
        AddHandler smtp.MessageReceive, AddressOf smtp_MessageReceive
        AddHandler smtp.MessageSend, AddressOf smtp_MessageSend

        '--------
        ' 暗号化
        '--------
        'smtp.AuthenticationProtocol = TKMP.Net.AuthenticationProtocols.TLS 'TLSでの暗号化通信を行います
        ' TKMP.Net.AuthenticationProtocols.SSL を使用する場合は接続ポートを995に変更してください
        'SSLを使用し証明書の検証を行うには次のイベントを使用してください
        'AddHandler smtp.CertificateValidation, AddressOf smtp_CertificateValidation

        '接続
        If Not smtp.Connect() Then
            System.Windows.Forms.MessageBox.Show("接続に失敗しました。")
            Return
        End If

        '------------------------------------------------------
        'メール送信を開始します
        '------------------------------------------------------
        smtp.SendMail(mail)


        '------------------------------------------------------
        'サーバーから切断します
        '------------------------------------------------------
        smtp.Close()


        System.Windows.Forms.MessageBox.Show("メールを送信しました")
    End Sub

    ' メッセージの受信イベント
    Private Sub smtp_MessageReceive(ByVal sender As Object, ByVal e As TKMP.Net.MessageArgs)
        richTextBox1.SelectionColor = System.Drawing.Color.Blue
        richTextBox1.AppendText(e.Message)
        richTextBox1.Focus()
        richTextBox1.Refresh()
    End Sub

    ' メッセージの送信イベント
    Private Sub smtp_MessageSend(ByVal sender As Object, ByVal e As TKMP.Net.MessageArgs)
        richTextBox1.SelectionColor = System.Drawing.Color.Red
        richTextBox1.AppendText(e.Message)
        richTextBox1.Focus()
        richTextBox1.Refresh()
    End Sub

    '証明書の内容を検証します
    Private Sub smtp_CertificateValidation(ByVal sender As Object, ByVal e As TKMP.Net.CertificateValidationArgs)
        e.Cancel = False '全ての証明書を信用します
    End Sub

End Class